using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace zadatak1
{
    public delegate double operacija(double a, double b);
    public delegate double operacijaNadJednomPromenjivom(double a);

    public partial class Form1 : Form
    {
        private double a,b;
        operacija delegatOperacija;
        private Boolean biloJednako;

        public Form1()
        {
            InitializeComponent();
        }

        private void pritisnutoDugme(object sender, MouseEventArgs e)
        {
            if (biloJednako) { label1.Text = ""; biloJednako = false; } 
            label1.Text += ((Button)sender).Text;
            b = double.Parse(label1.Text);
        }

        public double saberi(double a, double b) { return a + b; }
        public double oduzmi(double a, double b) { return a - b; }
        public double pomnozi(double a, double b) { return a * b; }
        public double podeli(double a, double b) { return a / b; }
        public double reciprocitetuj(double a) { return 1/a; }
        public double korenuj(double a) { return Math.Sqrt(a); }

        private void puta_Click(object sender, EventArgs e) {
            delegatOperacija = new operacija(pomnozi);
            a = double.Parse(label1.Text);  label1.Text = "";            
        }

        private void podeljeno_Click(object sender, EventArgs e) {
            delegatOperacija = new operacija(podeli);
            a = double.Parse(label1.Text); label1.Text = ""; 
        }

        private void plus_Click(object sender, EventArgs e) {
            delegatOperacija = new operacija(saberi);
            a = double.Parse(label1.Text); label1.Text = ""; 
        }

        private void minus_Click(object sender, EventArgs e) {
            delegatOperacija = new operacija(oduzmi);
            a = double.Parse(label1.Text); label1.Text = ""; 
        }

        private void jednako_Click(object sender, EventArgs e) {
            if (delegatOperacija!=null) {
                label1.Text = delegatOperacija(a, b).ToString(); 
                delegatOperacija = null;
                biloJednako = true;
            }
        }

        private void reciprocitet_Click(object sender, EventArgs e) {
            double x=0;
            if(double.TryParse(label1.Text,out x))
                label1.Text = reciprocitetuj(x).ToString();
        }

        private void koren_Click(object sender, EventArgs e) {
            double x = 0;
            if (double.TryParse(label1.Text, out x))
                label1.Text = korenuj(x).ToString();
        }

        private void pritisnutoDugme(object sender, KeyPressEventArgs e) {
            switch (e.KeyChar) {
                case '0':case '1':case '2':case '3':case '4':
                case '5':case '6':case '7':case '8':case '9':
                            if (biloJednako) { label1.Text = ""; biloJednako = false; }
                            label1.Text += e.KeyChar;
                            b = double.Parse(label1.Text);
                            break;
                case '+':   delegatOperacija = new operacija(saberi);
                            a = double.Parse(label1.Text); label1.Text = "";
                            break;
                case '-':   delegatOperacija = new operacija(oduzmi);
                            a = double.Parse(label1.Text); label1.Text = "";
                            break;
                case '*':   delegatOperacija = new operacija(pomnozi);
                            a = double.Parse(label1.Text); label1.Text = "";
                            break;
                case '%':case '/':
                            delegatOperacija = new operacija(podeli);
                            a = double.Parse(label1.Text); label1.Text = "";
                            break;
                case '=':   if (delegatOperacija != null) {
                                label1.Text = delegatOperacija(a, b).ToString();
                                delegatOperacija = null;
                                biloJednako = true;
                            }
                            break;                        
            } 
            
        }
    }
}